DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Sorting

The JavaScript DataGrid component can sort values by a single or multiple columns. Use the sorting.mode property to specify the sort mode.

Backend API
$(() => { const dataGrid = $('#gridContainer').dxDataGrid({ dataSource: employees, keyExpr: 'ID', showBorders: true, sorting: { mode: 'multiple', }, columns: [ { dataField: 'Prefix', caption: 'Title', width: 100, sortOrder: 'asc', }, { dataField: 'FirstName', sortOrder: 'asc', }, { dataField: 'LastName', }, 'City', 'State', { dataField: 'Position', width: 130, }, { dataField: 'HireDate', dataType: 'date', }, ], }).dxDataGrid('instance'); $('#positionSorting').dxCheckBox({ value: false, text: 'Disable Sorting for the Position Column', onValueChanged(data) { dataGrid.columnOption(5, 'sortOrder', undefined); dataGrid.columnOption(5, 'allowSorting', !data.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.7"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="gridContainer"></div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div id="positionSorting"></div> </div> </div> </div> </body> </html>
.options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; }
const employees = [{ ID: 1, FirstName: 'John', LastName: 'Heart', Phone: '(213) 555-9392', Prefix: 'Mr.', Position: 'CEO', BirthDate: '1964-03-16', HireDate: '1995-01-15', Email: 'jheart@dx-email.com', Address: '351 S Hill St.', City: 'Los Angeles', StateID: 5, State: 'California', HomePhone: '(213) 555-9208', Skype: 'jheartDXskype', }, { ID: 2, FirstName: 'Olivia', LastName: 'Peyton', Phone: '(310) 555-2728', Prefix: 'Mrs.', Position: 'Sales Assistant', BirthDate: '1981-06-03', HireDate: '2012-05-14', Email: 'oliviap@dx-email.com', Address: '807 W Paseo Del Mar', City: 'Los Angeles', StateID: 5, State: 'California', HomePhone: '(310) 555-4547', Skype: 'oliviapDXskype', }, { ID: 3, FirstName: 'Robert', LastName: 'Reagan', Phone: '(818) 555-2387', Prefix: 'Mr.', Position: 'CMO', BirthDate: '1974-09-07', HireDate: '2002-11-08', Email: 'robertr@dx-email.com', Address: '4 Westmoreland Pl.', City: 'Bentonville', StateID: 4, State: 'Arkansas', HomePhone: '(818) 555-2438', Skype: 'robertrDXskype', }, { ID: 4, FirstName: 'Greta', LastName: 'Sims', Phone: '(818) 555-6546', Prefix: 'Ms.', Position: 'HR Manager', BirthDate: '1977-11-22', HireDate: '1998-04-23', Email: 'gretas@dx-email.com', Address: '1700 S Grandview Dr.', City: 'Atlanta', StateID: 11, State: 'Georgia', HomePhone: '(818) 555-0976', Skype: 'gretasDXskype', }, { ID: 5, FirstName: 'Brett', LastName: 'Wade', Phone: '(626) 555-0358', Prefix: 'Mr.', Position: 'IT Manager', BirthDate: '1968-12-01', HireDate: '2009-03-06', Email: 'brettw@dx-email.com', Address: '1120 Old Mill Rd.', City: 'Boise', StateID: 13, State: 'Idaho', HomePhone: '(626) 555-5985', Skype: 'brettwDXskype', }, { ID: 6, FirstName: 'Sandra', LastName: 'Johnson', Phone: '(562) 555-2082', Prefix: 'Mrs.', Position: 'Controller', BirthDate: '1974-11-15', HireDate: '2005-05-11', Email: 'sandraj@dx-email.com', Address: '4600 N Virginia Rd.', City: 'Beaver', StateID: 44, State: 'Utah', HomePhone: '(562) 555-8272', Skype: 'sandrajDXskype', }, { ID: 7, FirstName: 'Kevin', LastName: 'Carter', Phone: '(213) 555-2840', Prefix: 'Mr.', Position: 'Shipping Manager', BirthDate: '1978-01-09', HireDate: '2009-08-11', Email: 'kevinc@dx-email.com', Address: '424 N Main St.', City: 'San Diego', StateID: 5, State: 'California', HomePhone: '(213) 555-8038', Skype: 'kevincDXskype', }, { ID: 8, FirstName: 'Cynthia', LastName: 'Stanwick', Phone: '(818) 555-6655', Prefix: 'Ms.', Position: 'HR Assistant', BirthDate: '1985-06-05', HireDate: '2008-03-24', Email: 'cindys@dx-email.com', Address: '2211 Bonita Dr.', City: 'Little Rock', StateID: 4, State: 'Arkansas', HomePhone: '(818) 555-6808', Skype: 'cindysDXskype', }, { ID: 9, FirstName: 'Kent', LastName: 'Samuelson', Phone: '(562) 555-9282', Prefix: 'Dr.', Position: 'Ombudsman', BirthDate: '1972-09-11', HireDate: '2009-04-22', Email: 'kents@dx-email.com', Address: '12100 Mora Dr', City: 'St. Louis', StateID: 26, State: 'Missouri', HomePhone: '(562) 555-1328', Skype: 'kentsDXskype', }, { ID: 10, FirstName: 'Taylor', LastName: 'Riley', Phone: '(310) 555-7276', Prefix: 'Mr.', Position: 'Network Admin', BirthDate: '1982-08-14', HireDate: '2012-04-14', Email: 'taylorr@dx-email.com', Address: '7776 Torreyson Dr', City: 'San Jose', StateID: 5, State: 'California', HomePhone: '(310) 555-9712', Skype: 'taylorrDXskype', }];
  • Single sort mode
    A user can click the column header to sort by this column and click it again to change the sort order (ascending or descending). An arrow icon in the column's header indicates the sort order.

  • Multiple sort mode
    A user can hold the Shift key and click column headers in the order the user wants to apply sorting. A number in the column's header indicates the sort index. To cancel a column's sort settings, a user should hold the Ctrl key and click the column header.

A user can also apply or cancel sort settings in the column header's context menu. To disallow a user to sort by a particular column, set the column's allowSorting property to false.

To specify the initial sort settings, use the column's sortOrder and sortIndex properties. You can also use these properties to change sort settings at runtime, as shown in this demo.

import React, { useCallback, useRef, useState } from 'react';
import DataGrid, { Column, Sorting } from 'devextreme-react/data-grid';
import type { DataGridRef } from 'devextreme-react/data-grid';
import CheckBox from 'devextreme-react/check-box';
import { employees } from './data.ts';
const App = () => {
const [positionDisableSorting, setPositionDisableSorting] = useState(false);
const dataGridRef = useRef<DataGridRef>(null);
const onPositionSortingChanged = useCallback(() => {
setPositionDisableSorting((previousPositionDisableSorting) => !previousPositionDisableSorting);
dataGridRef.current?.instance().columnOption(5, 'sortOrder', undefined);
}, []);
return (
<div>
<DataGrid
dataSource={employees}
keyExpr="ID"
showBorders={true}
ref={dataGridRef}
>
<Sorting mode="multiple" />
<Column dataField="Prefix" caption="Title" width={100} defaultSortOrder="asc" />
<Column dataField="FirstName" defaultSortOrder="asc" />
<Column dataField="LastName" />
<Column dataField="City" />
<Column dataField="State" />
<Column
dataField="Position"
allowSorting={!positionDisableSorting}
width={130}
/>
<Column dataField="HireDate" dataType="date" />
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Disable Sorting for the Position Column"
value={positionDisableSorting}
onValueChanged={onPositionSortingChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useRef, useState } from 'react';
import DataGrid, { Column, Sorting } from 'devextreme-react/data-grid';
import CheckBox from 'devextreme-react/check-box';
import { employees } from './data.js';
const App = () => {
const [positionDisableSorting, setPositionDisableSorting] = useState(false);
const dataGridRef = useRef(null);
const onPositionSortingChanged = useCallback(() => {
setPositionDisableSorting((previousPositionDisableSorting) => !previousPositionDisableSorting);
dataGridRef.current?.instance().columnOption(5, 'sortOrder', undefined);
}, []);
return (
<div>
<DataGrid
dataSource={employees}
keyExpr="ID"
showBorders={true}
ref={dataGridRef}
>
<Sorting mode="multiple" />
<Column
dataField="Prefix"
caption="Title"
width={100}
defaultSortOrder="asc"
/>
<Column
dataField="FirstName"
defaultSortOrder="asc"
/>
<Column dataField="LastName" />
<Column dataField="City" />
<Column dataField="State" />
<Column
dataField="Position"
allowSorting={!positionDisableSorting}
width={130}
/>
<Column
dataField="HireDate"
dataType="date"
/>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Disable Sorting for the Position Column"
value={positionDisableSorting}
onValueChanged={onPositionSortingChanged}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const employees = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Phone: '(213) 555-9392',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964-03-16',
HireDate: '1995-01-15',
Email: 'jheart@dx-email.com',
Address: '351 S Hill St.',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-9208',
Skype: 'jheartDXskype',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Phone: '(310) 555-2728',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981-06-03',
HireDate: '2012-05-14',
Email: 'oliviap@dx-email.com',
Address: '807 W Paseo Del Mar',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-4547',
Skype: 'oliviapDXskype',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Phone: '(818) 555-2387',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974-09-07',
HireDate: '2002-11-08',
Email: 'robertr@dx-email.com',
Address: '4 Westmoreland Pl.',
City: 'Bentonville',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-2438',
Skype: 'robertrDXskype',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Phone: '(818) 555-6546',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977-11-22',
HireDate: '1998-04-23',
Email: 'gretas@dx-email.com',
Address: '1700 S Grandview Dr.',
City: 'Atlanta',
StateID: 11,
State: 'Georgia',
HomePhone: '(818) 555-0976',
Skype: 'gretasDXskype',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Phone: '(626) 555-0358',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968-12-01',
HireDate: '2009-03-06',
Email: 'brettw@dx-email.com',
Address: '1120 Old Mill Rd.',
City: 'Boise',
StateID: 13,
State: 'Idaho',
HomePhone: '(626) 555-5985',
Skype: 'brettwDXskype',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Phone: '(562) 555-2082',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974-11-15',
HireDate: '2005-05-11',
Email: 'sandraj@dx-email.com',
Address: '4600 N Virginia Rd.',
City: 'Beaver',
StateID: 44,
State: 'Utah',
HomePhone: '(562) 555-8272',
Skype: 'sandrajDXskype',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Phone: '(213) 555-2840',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978-01-09',
HireDate: '2009-08-11',
Email: 'kevinc@dx-email.com',
Address: '424 N Main St.',
City: 'San Diego',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-8038',
Skype: 'kevincDXskype',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Phone: '(818) 555-6655',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985-06-05',
HireDate: '2008-03-24',
Email: 'cindys@dx-email.com',
Address: '2211 Bonita Dr.',
City: 'Little Rock',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-6808',
Skype: 'cindysDXskype',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Phone: '(562) 555-9282',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972-09-11',
HireDate: '2009-04-22',
Email: 'kents@dx-email.com',
Address: '12100 Mora Dr',
City: 'St. Louis',
StateID: 26,
State: 'Missouri',
HomePhone: '(562) 555-1328',
Skype: 'kentsDXskype',
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Phone: '(310) 555-7276',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982-08-14',
HireDate: '2012-04-14',
Email: 'taylorr@dx-email.com',
Address: '7776 Torreyson Dr',
City: 'San Jose',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-9712',
Skype: 'taylorrDXskype',
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employees = [
{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Phone: '(213) 555-9392',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964-03-16',
HireDate: '1995-01-15',
Email: 'jheart@dx-email.com',
Address: '351 S Hill St.',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-9208',
Skype: 'jheartDXskype',
},
{
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Phone: '(310) 555-2728',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981-06-03',
HireDate: '2012-05-14',
Email: 'oliviap@dx-email.com',
Address: '807 W Paseo Del Mar',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-4547',
Skype: 'oliviapDXskype',
},
{
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Phone: '(818) 555-2387',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974-09-07',
HireDate: '2002-11-08',
Email: 'robertr@dx-email.com',
Address: '4 Westmoreland Pl.',
City: 'Bentonville',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-2438',
Skype: 'robertrDXskype',
},
{
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Phone: '(818) 555-6546',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977-11-22',
HireDate: '1998-04-23',
Email: 'gretas@dx-email.com',
Address: '1700 S Grandview Dr.',
City: 'Atlanta',
StateID: 11,
State: 'Georgia',
HomePhone: '(818) 555-0976',
Skype: 'gretasDXskype',
},
{
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Phone: '(626) 555-0358',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968-12-01',
HireDate: '2009-03-06',
Email: 'brettw@dx-email.com',
Address: '1120 Old Mill Rd.',
City: 'Boise',
StateID: 13,
State: 'Idaho',
HomePhone: '(626) 555-5985',
Skype: 'brettwDXskype',
},
{
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Phone: '(562) 555-2082',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974-11-15',
HireDate: '2005-05-11',
Email: 'sandraj@dx-email.com',
Address: '4600 N Virginia Rd.',
City: 'Beaver',
StateID: 44,
State: 'Utah',
HomePhone: '(562) 555-8272',
Skype: 'sandrajDXskype',
},
{
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Phone: '(213) 555-2840',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978-01-09',
HireDate: '2009-08-11',
Email: 'kevinc@dx-email.com',
Address: '424 N Main St.',
City: 'San Diego',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-8038',
Skype: 'kevincDXskype',
},
{
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Phone: '(818) 555-6655',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985-06-05',
HireDate: '2008-03-24',
Email: 'cindys@dx-email.com',
Address: '2211 Bonita Dr.',
City: 'Little Rock',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-6808',
Skype: 'cindysDXskype',
},
{
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Phone: '(562) 555-9282',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972-09-11',
HireDate: '2009-04-22',
Email: 'kents@dx-email.com',
Address: '12100 Mora Dr',
City: 'St. Louis',
StateID: 26,
State: 'Missouri',
HomePhone: '(562) 555-1328',
Skype: 'kentsDXskype',
},
{
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Phone: '(310) 555-7276',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982-08-14',
HireDate: '2012-04-14',
Email: 'taylorr@dx-email.com',
Address: '7776 Torreyson Dr',
City: 'San Jose',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-9712',
Skype: 'taylorrDXskype',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}

<template>
<div>
<DxDataGrid
ref="dataGridRef"
:data-source="employees"
:show-borders="true"
key-expr="ID"
>
<DxColumn
:width="100"
data-field="Prefix"
caption="Title"
sort-order="asc"
/>
<DxColumn
data-field="FirstName"
sort-order="asc"
/>
<DxColumn
data-field="LastName"
/>
<DxColumn data-field="City"/>
<DxColumn data-field="State"/>
<DxColumn
:width="130"
:allow-sorting="!positionDisableSorting"
data-field="Position"
/>
<DxColumn
data-field="HireDate"
data-type="date"
/>
<DxSorting mode="multiple"/>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="positionDisableSorting"
text="Disable Sorting for the Position Column"
@value-changed="onValueChanged"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxColumn,
DxDataGrid,
DxSorting,
} from 'devextreme-vue/data-grid';
import DxCheckBox from 'devextreme-vue/check-box';
import { employees } from './data.ts';
const positionDisableSorting = ref(false);
const dataGridRef = ref<DxDataGrid | null>(null);
const onValueChanged = () => {
dataGridRef.value!.instance!.columnOption(5, 'sortOrder', undefined);
};
</script>
<style scoped>
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.66/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export type Employee = {
ID: number;
FirstName: string;
LastName: string;
Phone: string;
Prefix: string;
Position: string;
BirthDate: string;
HireDate: string;
Email: string;
Address: string;
City: string;
State: string;
StateID: number;
HomePhone: string;
Skype: string;
};
export const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Phone: '(213) 555-9392',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964-03-16',
HireDate: '1995-01-15',
Email: 'jheart@dx-email.com',
Address: '351 S Hill St.',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-9208',
Skype: 'jheartDXskype',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Phone: '(310) 555-2728',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981-06-03',
HireDate: '2012-05-14',
Email: 'oliviap@dx-email.com',
Address: '807 W Paseo Del Mar',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-4547',
Skype: 'oliviapDXskype',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Phone: '(818) 555-2387',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974-09-07',
HireDate: '2002-11-08',
Email: 'robertr@dx-email.com',
Address: '4 Westmoreland Pl.',
City: 'Bentonville',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-2438',
Skype: 'robertrDXskype',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Phone: '(818) 555-6546',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977-11-22',
HireDate: '1998-04-23',
Email: 'gretas@dx-email.com',
Address: '1700 S Grandview Dr.',
City: 'Atlanta',
StateID: 11,
State: 'Georgia',
HomePhone: '(818) 555-0976',
Skype: 'gretasDXskype',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Phone: '(626) 555-0358',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968-12-01',
HireDate: '2009-03-06',
Email: 'brettw@dx-email.com',
Address: '1120 Old Mill Rd.',
City: 'Boise',
StateID: 13,
State: 'Idaho',
HomePhone: '(626) 555-5985',
Skype: 'brettwDXskype',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Phone: '(562) 555-2082',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974-11-15',
HireDate: '2005-05-11',
Email: 'sandraj@dx-email.com',
Address: '4600 N Virginia Rd.',
City: 'Beaver',
StateID: 44,
State: 'Utah',
HomePhone: '(562) 555-8272',
Skype: 'sandrajDXskype',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Phone: '(213) 555-2840',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978-01-09',
HireDate: '2009-08-11',
Email: 'kevinc@dx-email.com',
Address: '424 N Main St.',
City: 'San Diego',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-8038',
Skype: 'kevincDXskype',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Phone: '(818) 555-6655',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985-06-05',
HireDate: '2008-03-24',
Email: 'cindys@dx-email.com',
Address: '2211 Bonita Dr.',
City: 'Little Rock',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-6808',
Skype: 'cindysDXskype',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Phone: '(562) 555-9282',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972-09-11',
HireDate: '2009-04-22',
Email: 'kents@dx-email.com',
Address: '12100 Mora Dr',
City: 'St. Louis',
StateID: 26,
State: 'Missouri',
HomePhone: '(562) 555-1328',
Skype: 'kentsDXskype',
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Phone: '(310) 555-7276',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982-08-14',
HireDate: '2012-04-14',
Email: 'taylorr@dx-email.com',
Address: '7776 Torreyson Dr',
City: 'San Jose',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-9712',
Skype: 'taylorrDXskype',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.5/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-data-grid
id="gridContainer"
[dataSource]="employees"
keyExpr="ID"
[showBorders]="true"
>
<dxo-data-grid-sorting mode="multiple"></dxo-data-grid-sorting>
<dxi-data-grid-column
dataField="Prefix"
caption="Title"
[width]="100"
sortOrder="asc"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="FirstName"
sortOrder="asc"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="LastName"></dxi-data-grid-column>
<dxi-data-grid-column dataField="City"></dxi-data-grid-column>
<dxi-data-grid-column dataField="State"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Position"
[width]="130"
[allowSorting]="!positionDisableSorting"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="HireDate"
dataType="date"
></dxi-data-grid-column>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
[(value)]="positionDisableSorting"
(onValueChanged)="onValueChange($event)"
text="Disable Sorting for the Position Column"
>
</dx-check-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxDataGridComponent, DxDataGridModule } from 'devextreme-angular';
import { DxCheckBoxModule, DxCheckBoxTypes } from 'devextreme-angular/ui/check-box';
import { Employee, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxDataGridModule,
DxCheckBoxModule,
],
})
export class AppComponent {
@ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
employees: Employee[];
positionDisableSorting = false;
constructor(service: Service) {
this.employees = service.getEmployees();
}
onValueChange(e: DxCheckBoxTypes.ValueChangedEvent) {
if (e.value) {
this.dataGrid.instance.columnOption(5, 'sortOrder', undefined);
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Phone: string;
Prefix: string;
Position: string;
BirthDate: string;
HireDate: string;
Email: string;
Address: string;
City: string;
State: string;
StateID: number;
HomePhone: string;
Skype: string;
}
const employees: Employee[] = [{
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Phone: '(213) 555-9392',
Prefix: 'Mr.',
Position: 'CEO',
BirthDate: '1964-03-16',
HireDate: '1995-01-15',
Email: 'jheart@dx-email.com',
Address: '351 S Hill St.',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-9208',
Skype: 'jheartDXskype',
}, {
ID: 2,
FirstName: 'Olivia',
LastName: 'Peyton',
Phone: '(310) 555-2728',
Prefix: 'Mrs.',
Position: 'Sales Assistant',
BirthDate: '1981-06-03',
HireDate: '2012-05-14',
Email: 'oliviap@dx-email.com',
Address: '807 W Paseo Del Mar',
City: 'Los Angeles',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-4547',
Skype: 'oliviapDXskype',
}, {
ID: 3,
FirstName: 'Robert',
LastName: 'Reagan',
Phone: '(818) 555-2387',
Prefix: 'Mr.',
Position: 'CMO',
BirthDate: '1974-09-07',
HireDate: '2002-11-08',
Email: 'robertr@dx-email.com',
Address: '4 Westmoreland Pl.',
City: 'Bentonville',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-2438',
Skype: 'robertrDXskype',
}, {
ID: 4,
FirstName: 'Greta',
LastName: 'Sims',
Phone: '(818) 555-6546',
Prefix: 'Ms.',
Position: 'HR Manager',
BirthDate: '1977-11-22',
HireDate: '1998-04-23',
Email: 'gretas@dx-email.com',
Address: '1700 S Grandview Dr.',
City: 'Atlanta',
StateID: 11,
State: 'Georgia',
HomePhone: '(818) 555-0976',
Skype: 'gretasDXskype',
}, {
ID: 5,
FirstName: 'Brett',
LastName: 'Wade',
Phone: '(626) 555-0358',
Prefix: 'Mr.',
Position: 'IT Manager',
BirthDate: '1968-12-01',
HireDate: '2009-03-06',
Email: 'brettw@dx-email.com',
Address: '1120 Old Mill Rd.',
City: 'Boise',
StateID: 13,
State: 'Idaho',
HomePhone: '(626) 555-5985',
Skype: 'brettwDXskype',
}, {
ID: 6,
FirstName: 'Sandra',
LastName: 'Johnson',
Phone: '(562) 555-2082',
Prefix: 'Mrs.',
Position: 'Controller',
BirthDate: '1974-11-15',
HireDate: '2005-05-11',
Email: 'sandraj@dx-email.com',
Address: '4600 N Virginia Rd.',
City: 'Beaver',
StateID: 44,
State: 'Utah',
HomePhone: '(562) 555-8272',
Skype: 'sandrajDXskype',
}, {
ID: 7,
FirstName: 'Kevin',
LastName: 'Carter',
Phone: '(213) 555-2840',
Prefix: 'Mr.',
Position: 'Shipping Manager',
BirthDate: '1978-01-09',
HireDate: '2009-08-11',
Email: 'kevinc@dx-email.com',
Address: '424 N Main St.',
City: 'San Diego',
StateID: 5,
State: 'California',
HomePhone: '(213) 555-8038',
Skype: 'kevincDXskype',
}, {
ID: 8,
FirstName: 'Cynthia',
LastName: 'Stanwick',
Phone: '(818) 555-6655',
Prefix: 'Ms.',
Position: 'HR Assistant',
BirthDate: '1985-06-05',
HireDate: '2008-03-24',
Email: 'cindys@dx-email.com',
Address: '2211 Bonita Dr.',
City: 'Little Rock',
StateID: 4,
State: 'Arkansas',
HomePhone: '(818) 555-6808',
Skype: 'cindysDXskype',
}, {
ID: 9,
FirstName: 'Kent',
LastName: 'Samuelson',
Phone: '(562) 555-9282',
Prefix: 'Dr.',
Position: 'Ombudsman',
BirthDate: '1972-09-11',
HireDate: '2009-04-22',
Email: 'kents@dx-email.com',
Address: '12100 Mora Dr',
City: 'St. Louis',
StateID: 26,
State: 'Missouri',
HomePhone: '(562) 555-1328',
Skype: 'kentsDXskype',
}, {
ID: 10,
FirstName: 'Taylor',
LastName: 'Riley',
Phone: '(310) 555-7276',
Prefix: 'Mr.',
Position: 'Network Admin',
BirthDate: '1982-08-14',
HireDate: '2012-04-14',
Email: 'taylorr@dx-email.com',
Address: '7776 Torreyson Dr',
City: 'San Jose',
StateID: 5,
State: 'California',
HomePhone: '(310) 555-9712',
Skype: 'taylorrDXskype',
}];
@Injectable()
export class Service {
getEmployees(): Employee[] {
return employees;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>